.\"-------
.\" Man page portability notes
.\"
.\" These are some notes on conventions to maintain for greatest
.\" portability of this man page to various other versions of
.\" nroff.
.\"
.\" When you want a \ to appear in the output, use \e in the man page.
.\" (NOTE this comes up in the rc grammar, where to print out '\n' the
.\" man page must contain '\en'.)
.\"
.\" Evidently not all versions of nroff allow the omission of the
.\" terminal " on a macro argument.  Thus what could be written
.\"
.\" .Cr "exec >[2] err.out
.\"
.\" in true nroffs must be written
.\"
.\" .Cr "exec >[2] err.out"
.\"
.\" instead.
.\"
.\" Use symbolic font names (e.g. R, I, B) instead of the standard
.\" font positions 1, 2, 3.  Note that for Xf to work the standard
.\" font names must be single characters.
.\"
.\" Note that sentences should end at the end of a line.  nroff and
.\" troff will supply the correct inter-sentence spacing, but only if
.\" the sentences end at the end of a line.  Explicit spaces, if given,
.\" are apparently honored and the normal inter-sentence spacing is
.\" suppressed.
.\"
.\" David W. Sanderson
.\"-------
.\" Dd	distance to space vertically before a "display"
.\" These are what n/troff use for inter-paragraph distance
.\"-------
.if t .nr Dd .4v
.if n .nr Dd 1v
.\"-------
.\" Sp	space down the inter-paragraph distance
.\"-------
.de Sp
.sp \\n(Ddu
..
.\"-------
.\" Ds	begin a display, indented .5 inches from the surrounding text.
.\"
.\" Note that uses of Ds and De may NOT be nested.
.\"-------
.de Ds
.Sp
.in +0.5i
.nf
..
.\"-------
.\" De	end a display (no trailing vertical spacing)
.\"-------
.de De
.fi
.in
..
.TH LockVC 1 "" "(c) 1994,1995,1997. Matthias Straub."
.\"-------
.SH "NAME"
.\"-------
.I LockVC
-- vga console-locking-program. 
.PP
.\"-------
.SH "SYNOPSIS"
.\"-------
.B lockvc
.PP
Start 
.I lockvc -help
to get a complete list of options.
.PP  
.\"-------
.SH "DESCRIPTION"
.\"-------
You're familiar with the situation:
You leave your computer alone to get a bottle of the world's most
famous soft drink, and when you come back, your terminal's taken,
your data's lost, your resources destroyed, and the system's
admin is asking you about those postings you've made on
alt.binaries.pictures.erotica.
Now it is too late to be sorry. You should have known better:
This happened a thousand times before.
Until now...
.PP
.I LockVC
is a console-locking-program combined with 
some nifty vga-screensavers. The version at this date (Nov 97) is 3.0.
Executing
.I LockVC
on a virtual console brings up a randomly chosen vga-screensaver
(that doesn't really save your screen, though).
To select a screensaver, run
.I lockvc -help
for a complete list.
.PP
All virtual consoles get locked, i.e. you cannot change to
another VC and you can't stop the program by pressing any key-combos
(apart from ctrl-alt-delete, if not disabled by your admin).
You can only exit the program by entering your system-password.
Root's password will also terminate lockvc.
The amount of time, that the VCs can be locked may be limited by your
system's admin.  This will be displayed on executing lockvc.
If you fail to exit lockvc within this time, lockvc will
terminate all your processes and log you out.
.PP
Svgalib is required on your
system and lockvc has to be run with root-privileges. Only standard
vga-modes are used. This should work on any reasonable machine.
.PP 
.\"-------
.SH "AUTHORS"
.\"-------
.I LockVC
was written by Matthias Straub,
.I University of Karlsruhe, Germany
(s_straub@ira.uka.de).
.PP
Shadow Password Support and Man Page added by Eddie Beaumont
.I (Morlok)
(morlok@abyss.apana.org.au).
.PP
.\"-------
.SH "BUGS"
.\"-------
LockVC eats up all cpu-time :(
